{ inputs, config, lib, nur, emacs, ... }:

{
  hostConfigFile
, architecture ? "x86_64-linux"
}: let
  pkgs = inputs.nixpkgs;
  config = pkgs.lib;
  network = import ./network.nix;

  util = import ./default.nix {
    inherit inputs config lib;
  };

  #primaryInterfaceWrapper = if wifiInterface != "" && primaryInterface == "" then wifiInterface else primaryInterface;
in inputs.nixpkgs.lib.nixosSystem {
  system = architecture;

  modules = [
    inputs.home-manager.nixosModules.home-manager
    {
      home-manager.useGlobalPkgs = true;
    }

    (util.mkOverlayFromInput "stable" inputs.stable)
    (util.mkOverlayFromInput "unstable" inputs.nixpkgs)

    {
      nixpkgs.overlays = [
        nur.overlay
        emacs.overlay
        (import ../packages)
      ];
    }

    (import ../modules)
    
    inputs.ostylk.nixosModules.nftables

    (import ./baseSystem.nix)
    (import hostConfigFile)
  ];
  
  specialArgs = {
    inherit inputs;
  };
}
